=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2013-02-27 11:48:55 +0000
+++ CMakeLists.txt	2013-05-12 08:20:10 +0000
@@ -104,7 +104,7 @@
     x11-xcb
     xrandr
     xinerama
-    xext
+    xi
     ice
     sm
     libxml-2.0

=== modified file 'src/privatescreen.h'
--- src/privatescreen.h	2013-02-27 03:24:45 +0000
+++ src/privatescreen.h	2013-05-12 08:20:10 +0000
@@ -744,6 +744,7 @@
 
     Window wmSnSelectionWindow;
 
+    int    clientPointerDeviceId;
     Cursor normalCursor;
     Cursor busyCursor;
     Cursor invisibleCursor;

=== modified file 'src/screen.cpp'
--- src/screen.cpp	2013-02-03 17:58:29 +0000
+++ src/screen.cpp	2013-05-12 08:20:10 +0000
@@ -52,6 +52,7 @@
 #include <X11/extensions/Xrandr.h>
 #include <X11/extensions/shape.h>
 #include <X11/cursorfont.h>
+#include <X11/extensions/XInput2.h>
 
 #include <core/global.h>
 #include <core/screen.h>
@@ -2082,9 +2083,9 @@
     if (priv->initialized)
     {
 	if (!emptySequence())
-	    XDefineCursor (priv->dpy, priv->rootWindow(), priv->busyCursor);
+	    XIDefineCursor (priv->dpy, priv->clientPointerDeviceId, priv->rootWindow(), priv->busyCursor);
 	else
-	    XDefineCursor (priv->dpy, priv->rootWindow(), priv->normalCursor);
+	    XIDefineCursor (priv->dpy, priv->clientPointerDeviceId, priv->rootWindow(), priv->normalCursor);
     }
 }
 
@@ -5002,10 +5003,12 @@
     eventManager.setSupportingWmCheck (dpy, rootWindow());
     screen->updateSupportedWmHints ();
 
+    XIGetClientPointer (dpy, None, &clientPointerDeviceId);
+
     normalCursor = XCreateFontCursor (dpy, XC_left_ptr);
     busyCursor   = XCreateFontCursor (dpy, XC_watch);
 
-    XDefineCursor (dpy, rootWindow(), normalCursor);
+    XIDefineCursor (dpy, clientPointerDeviceId, rootWindow(), normalCursor);
 
     /* Attempt to gain SubstructureRedirectMask */
     CompScreenImpl::checkForError (dpy);
@@ -5180,6 +5183,7 @@
     nDesktop (1),
     currentDesktop (0),
     wmSnSelectionWindow (None),
+    clientPointerDeviceId (None),
     normalCursor (None),
     busyCursor (None),
     invisibleCursor (None),

